## Customer Management System

- Version: 0.0.1
- Date: 11/06/2023
- Author: Ahmad Hamdan &lt;hamdan.ahmad.lb@gmail.com&gt;
- Git Repository: https://gitlab.com/ahmad.hamdan/customer-managment-sample-api

This project is a sample project of a customer management system.

### Overview

The project provides a simple full stack app for managing customer. This includes: creating, reading, editing, and deleting customers. It consists of four components:

- **Number Validation API**: Responsible for checking phonenumber details and check its details
- **Customer Management API**: Received REST APIs from the frontend application, validate the
- **Database**: used to store data of the customers. PostgreSQL is used.
- **Frontend**: a simple React app to perform CRUD operations by consuming backend REST APIs.phonenumbers of customers by consuming Number Validation API, and fetch/customer information using the database.

The four components of the system integrates to each others as follows:

<p align="center">
<img src="https://www.plantuml.com/plantuml/svg/ZS_1wXCn40RmUvvYNCzz02_ohnR1WrfgzRINsMHs6vlCB9E9AEAx6z9Q5q5m5y87-_iciq_5KAtcv9xPXJ91HYEDk9DgAJ8vbsWsC06DoyKWH2LlKTYLQ-GL5JC4ch4cEzCtswUuS2OsyEqWtQW9_NLHgHoy954uAt9fdvhRgBaTD8a6qXlxaE9NEYXEVwDPsFvDV98Q_k_AJlzCU_wYFywXDr4OFXNI0R10BQvV3CDHvGjvWuzULXhWX_EILs5YW-6D2Xjn6Fb4w6ta_Rhs-apt-YlqrmPQBQ3XXALDFDnJbs7Q3dnVyqGAdp75vgCmx8zlksFSkjUrcEGcto7ZGfdO7jAZ-zdU_gSmd2YBqSZdIzG0HrJxFl9lgkXSBR3RlUmRKq-jxx4dVgIs9T-IediY3ZMdNm00" />
</p>

### Backend Components

In this section, further documentation about the backend component is provided. The database tables are automatically generated by the Customer Management API since JPA is used, and the frontend section is minimal and only reflects the Customer Management API. Therefore, both were omitted from this section, but the documentation for running them is provided in a later section.

#### Number Validation API

This API checks if a phonenumber is valid or not. The service itself does not implement any validation, especially that the validity of phonenumbers can vary with time. Therefore, it forwards the requests to a well-known free phonenumber checking API: `http://phone-number-api.com/json?number={number}`. This service exposes the following endpoint:

##### GET /phonenumber/{number}

Request Example:

```bash
curl -X 'GET' \
'http://localhost:8080/phonenumbers/96170123456' \
-H 'accept: application/json'
```

Response Examples:

- Valid phone number
  - Code: `200` Success
  - Body:

```json
{
 "operatorName": "Alfa",
 "countryName": "Lebanon",
 "countryCode": "961"
}
```

- Invalid phone number
  - Code: `204` No Content

- Unexpected error
  - Code: `500` Internal Server Error

##### GET /swagger-ui.html

This API exposes interactive documentation of the service.

#### Customer Management API

This API is responsible for the Create, Read, Update, and Delete (CRUD) operation on customers. The customer structure adopted for this API is in the following format:

```json
Customer {
"id": uuid,
"name": string,
"address": string,
"number": string
}
```

The `id` field is omitted from requests bodies, as it is only useful for responses. This service exposes the following endpoint:

##### POST /customers

Request Example:

```bash
curl -X 'POST' \
'http://localhost:8090/customers' \
-H 'accept: application/json' \
-H 'Content-Type: application/json' \
-d '{
"name": "Name",
"address": "Address",
"number": "96170123456"
}'
```

Response Examples:

- Customer created
  - Code: `201` Created
  - Header: `location=/customer/3fa85f64-5717-4562-b3fc-2c963f66afa6`
  - Body:

```json
{
 "id": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
 "name": "Name",
 "address": "Address",
 "number": "96170123456"
}
```

- Invalid phone number
  - Code: `400` Bad Request
  - Body:

```json
{
 "type": "about:blank",
 "title": "Bad Request",
 "status": 400,
 "detail": "Invalid phone number",
 "instance": "/customers"
}
```

- Unexpected error
  - Code: `500` Internal Server Error

##### GET /customers

Request Example:

```bash
curl -X 'GET' \
'http://localhost:8090/customers?name=&address=&number=&page=&size=&sort=name' \
-H 'accept: */*'
```

Response Examples:

- Success
  - Code: `200` OK
  - Body (truncated for clarity):

```json
{
 "content": [
  {
   "id": "57f61103-e4ba-4764-b5b1-91ca83ab7a08",
   "name": "Name",
   "address": "Address",
   "number": "96171123456"
  },
  ...
 ],
 "pageable": {
  "sort": {
   "sorted": true,
   "unsorted": false,
   "empty": false
  },
  "pageNumber": 0,
  "pageSize": 10,
  "offset": 0,
  "paged": true,
  "unpaged": false
 },
 ...
}
```

- Bad Request
  - Code: `400` Bad Request
  - Body:

```json
{
 "type": "about:blank",
 "title": "Bad Request",
 "status": 400,
 "detail": "No property 'names' found for type 'Customer'; Did you mean 'name'",
 "instance": "/customers"
}
```

- Unexpected error
  - Code: `500` Internal Server Error

##### GET /customers/{id}

Request Example:

```bash
curl -X 'GET' \
'http://localhost:8090/customers/57f61103-e4ba-4764-b5b1-91ca83ab7a08' \
-H 'accept: */*'
```

Response Examples:

- Success
  - Code: `200` OK
  - Body:

```json
{
 "id": "57f61103-e4ba-4764-b5b1-91ca83ab7a08",
 "name": "Name",
 "address": "Address",
 "number": "96171123456"
}
```

- Not Found
  - Code: `204` No Content

- Bad Request
  - Code: `400` Bad Request
  - Body:

```json
{
 "type": "about:blank",
 "title": "Bad Request",
 "status": 400,
 "detail": "Type mismatch.",
 "instance": "/customers/not-a-uuid"
}
```

- Unexpected error
  - Code: `500` Internal Server Error

##### PUT /customers/{id}

Request Example:

```bash
curl -X 'PUT' \
'http://localhost:8090/customers/57f61103-e4ba-4764-b5b1-91ca83ab7a08' \
-H 'accept: application/json' \
-H 'Content-Type: application/json' \
-d '{
"name": "Full Name",
"address": "Address",
"number": "96170123456"
}'
```

Response Examples:

- Success
  - Code: `200` OK
  - Body:

```json
{
 "id": "57f61103-e4ba-4764-b5b1-91ca83ab7a08",
 "name": "Full Name",
 "address": "Address",
 "number": "96171123456"
}
```

- Not Found
  - Code: `204` No Content

- Bad Request
  - Code: `400` Bad Request
  - Body:

```json
{
 "type": "about:blank",
 "title": "Bad Request",
 "status": 400,
 "detail": "Type mismatch.",
 "instance": "/customers/not-a-uuid"
}
```

- Unexpected error
  - Code: `500` Internal Server Error

##### DELETE /customers/{id}

Request Example:

```bash
curl -X 'DELETE' \
'http://localhost:8090/customers/57f61103-e4ba-4764-b5b1-91ca83ab7a08' \
-H 'accept: */*'
```

Response Examples:

- Success
  - Code: `200` OK

- Not Found
  - Code: `204` No Content

- Bad Request
  - Code: `400` Bad Request
  - Body:

```json
{
 "type": "about:blank",
 "title": "Bad Request",
 "status": 400,
 "detail": "Type mismatch.",
 "instance": "/customers/not-a-uuid"
}
```

- Unexpected error
  - Code: `500` Internal Server Error

### Launching The Services

In this project, we consider using docker as the the technology to run the applications. For the database, we will use an official docker image. For the other three compoenents, we will build the images using the docker files within each folder.

Building and launching the services is made easy using the bash scripts `build.sh` and `deploy.sh`. You should have docker installed on your local machine to run them. However, to build the docker images, it is enough to run run `./build.sh`, and to deploy/replace them, it is enough to run `./deploy.sh`. Please note that this might take very long time for the first time, then faster for later runs due to pulling remote content.

### Improvements

This project is a sample project, yet it uses an advanced concept in service development which is the reactive-based APIs. Using the spring webflux project and the netty server, this service provide an efficient way for controlling the server (although at the cost of being harder to code).

On the other hand, it has a great room for improvement. Among these possible improvement we have:

- Adding validation for the Name and Address. We normally have validation on these, like lenght and allowed characters, but this was outside the scope of this sample.
- Adding a dropdown for the country code of the phone number to make is more obvious that it is required as prefix to the phone number.
- Add multi-language support.
- Improve the frontend to use the already implemented backend pagination and sorting.
- Add automated pipelined for automated builds.
- Add automated documentation generation using Spring RestDoc project.
- Add kubernetes nodes manifest files.
- Add authentication layer.
